Set objShell = CreateObject("Shell.Application")

' Check if the script is already elevated
If Not WScript.Arguments.Named.Exists("elevated") Then
    ' Get the current script path and relaunch with admin privileges
    scriptPath = """" & WScript.ScriptFullName & """ /elevated"
    objShell.ShellExecute "wscript.exe", scriptPath, "", "runas", 1
    WScript.Quit
End If

' Main code logic after elevation

Dim objFSO, objDrive, objDrives, objShell, objExec, output, desktopPath, upgradeFolder, filePath, objFile, osVersion, isWindows11, objNetwork, userName, adminCheck, sourcePath, targetPath, strMessage, outputmsg

' Create FileSystemObject and Shell Object
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objShell = CreateObject("WScript.Shell")
Set objNetwork = CreateObject("WScript.Network")

strMessage = strMessage & "Reminder:" & vbCrLf
strMessage = strMessage & vbCrLf & "1. Remember to backup your data to NUS Dropbox before starting the upgrade." & vbCrLf
strMessage = strMessage & "2. Keep the device plugged in to a power source and stay connected to the network during the upgrade." & vbCrLf & vbCrLf
strMessage = strMessage & "Running Pre-checks:" & vbCrLf & vbCrLf

' Get OS version from the registry
osVersion = GetBuildNumber()
isWindows11 = False

strMessage = strMessage & "1. Operating System eligible for upgrade: Yes" & vbCrLf

' Check OS Version
If osVersion >= 1904 Then
	If osVersion >= 22000 Then ' Windows 11 starts from build 22000
        WScript.Echo "Operating System is Windows 11, no action required."
        WScript.Quit
    Else
        output = output & "Checking Operating System Compatibility: Passed" & vbCrLf
    End If
Else
   WScript.Echo "Checking Operating System Compatibility: Failed - Contact your department Admin."
    WScript.Quit
End If


' Check Admin Access
On Error Resume Next
If CheckAdminAccess() Or IsCyberArkEPMInstalled() Then
    strMessage = strMessage & "2. Logon account has Admin rights: Yes" & vbCrLf
Else
    WScript.Echo "Logon account does not have Admin rights - Contact your department Admin."
    WScript.Quit
End If
On Error GoTo 0

' Get the Desktop path
desktopPath = objShell.SpecialFolders("Desktop")
upgradeFolder = desktopPath & "\Windows 11 Upgrade"

' Create the "Windows 11 Upgrade" folder if it doesn't exist
If Not objFSO.FolderExists(upgradeFolder) Then
    objFSO.CreateFolder upgradeFolder
End If

' Define the output file path
filePath = upgradeFolder & "\bitlockerkeys.txt"

' Create or open the output file
Set objFile = objFSO.CreateTextFile(filePath, True)

' Create Drives object
Set objDrives = objFSO.Drives

' Loop through all drives
For Each objDrive In objDrives
    If objDrive.DriveType = 2 Then ' Fixed drive
        output = output & "Checking BitLocker status for Drive: " & objDrive.DriveLetter & ":" & vbCrLf
        
        ' Execute manage-bde command for the fixed drive
        On Error Resume Next
        Set objExec = objShell.Exec("cmd.exe /c manage-bde -status " & objDrive.DriveLetter & ":")
        On Error GoTo 0
        
        If Not objExec Is Nothing Then
            ' Read the output of the manage-bde command
            Do Until objExec.StdOut.AtEndOfStream
                output = output & objExec.StdOut.ReadLine() & vbCrLf
            Loop
            
            ' If BitLocker is enabled, fetch protectors
            If InStr(output, "Percentage Encrypted") > 0 Then
                output = output & "Fetching BitLocker recovery keys for Drive: " & objDrive.DriveLetter & ":" & vbCrLf
                Set objExec = objShell.Exec("cmd.exe /c manage-bde -protectors -get " & objDrive.DriveLetter & ":")
                Do Until objExec.StdOut.AtEndOfStream
                    output = output & objExec.StdOut.ReadLine() & vbCrLf
                Loop
            Else
                output = output & "No BitLocker status found for Drive: " & objDrive.DriveLetter & ":" & vbCrLf
            End If
        Else
            output = output & "Unable to execute manage-bde for Drive: " & objDrive.DriveLetter & ":" & vbCrLf
        End If
        
        ' Write output to file
        objFile.WriteLine output
        
        ' Display output in console (optional)
        ' WScript.Echo output
    End If
Next

' Close the file
objFile.Close

strMessage = strMessage &  vbCrLf & "********************** MANDATORY **********************" & vbCrLf & vbCrLf
strMessage = strMessage &  "The following files are saved in the folder 'Windows 11 Upgrade' on your desktop" & vbCrLf & vbCrLf
strMessage = strMessage &  "1. 'bitlockerkeys.txt' contains the Bitlocker recovery password. Copy this file to NUS Dropbox." & vbCrLf & vbCrLf


' Copy Installer Files
sourcePath = "\\fs5.nus.edu.sg\StfPC\ITCare"
targetPath = upgradeFolder 

' Create the target folder if it doesn't exist
If Not objFSO.FolderExists(targetPath) Then
    objFSO.CreateFolder(targetPath)
End If

On Error Resume Next
objFSO.CopyFolder sourcePath, targetPath, True
If Err.Number = 0 Then
    strMessage = strMessage & "2. 'Windows11InstallationAssistant': Launch this file to start the upgrade" & vbCrLf
Else
    WScript.Echo "Copying Installer: Failed - Refer to KA to download it manaully."
    WScript.Quit
End If
On Error GoTo 0

strMessage = strMessage &  "**********************************************************" & vbCrLf & vbCrLf
WScript.Echo strMessage & vbCrLf & "All pre-checks completed successfully. Refer to the KA to continue upgrade." & vbCrLf & vbCrLf


Function CheckAdminAccess()
    Dim objShell, objExec, output, errorFlag

    ' Create a Shell object
    Set objShell = CreateObject("WScript.Shell")

    ' Execute the "net session" command
    On Error Resume Next
    Set objExec = objShell.Exec("cmd.exe /c net session")
    On Error GoTo 0

    ' Initialize the error flag
    errorFlag = False

    If Not objExec Is Nothing Then
        ' Read the output of the command
        output = ""
        Do Until objExec.StdOut.AtEndOfStream
            output = output & objExec.StdOut.ReadLine() & vbCrLf
        Loop
        
        ' Check if "Access is denied" is in the output
        If Len(output) = 0 Then
            errorFlag = False
        Else
        	errorFlag = True
        End If
    Else
        WScript.Echo "Failed to execute command. - Contact IT Care."
        WScript.Quit
    End If
	
    ' Cleanup
    Set objShell = Nothing
    Set objExec = Nothing

    ' Return result based on the error flag
    CheckAdminAccess = errorFlag
End Function

Function IsElevatedPrompt()
    Dim objShell, objExec, output, isElevated

    ' Create a Shell object
    Set objShell = CreateObject("WScript.Shell")

    ' Execute the "net session" command
    On Error Resume Next
    Set objExec = objShell.Exec("cmd.exe /c net session")
    On Error GoTo 0

    ' Initialize the elevated flag
    isElevated = False

    If Not objExec Is Nothing Then
        ' Read the output of the command
        output = ""
        Do Until objExec.StdOut.AtEndOfStream
            output = output & objExec.StdOut.ReadLine() & vbCrLf
        Loop
        
        ' Check if "Access is denied" is in the output
        If InStr(output, "Access is denied") = 0 Then
            isElevated = True
        End If
    End If

    ' Cleanup
    Set objShell = Nothing
    Set objExec = Nothing

    ' Return result based on the elevated flag
    IsElevated = isElevated
End Function

Function IsCyberArkEPMInstalled()
    Dim objWMIService, colSubkeys, subkey, programName
    Dim strComputer, regPath

    strComputer = "."
    regPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\"

    ' Connect to WMI registry provider
    Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\default:StdRegProv")

    ' Enumerate subkeys under the Uninstall key
    objWMIService.EnumKey &H80000002, regPath, colSubkeys

    If Not IsNull(colSubkeys) Then
        For Each subkey In colSubkeys
            ' Read DisplayName of each program
            objWMIService.GetStringValue &H80000002, regPath & subkey, "DisplayName", programName
            If Not IsNull(programName) Then
                If InStr(1, programName, "CyberArk Endpoint Privilege Manager", vbTextCompare) > 0 Then
                    ' CyberArk EPM found, return True
                    IsCyberArkEPMInstalled = True
                    Exit Function
                End If
            End If
        Next
    End If

    ' If we reach here, CyberArk EPM is not installed
    IsCyberArkEPMInstalled = False
End Function

Function GetBuildNumber()
    ' Create a WMI object
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")

    ' Query the Win32_OperatingSystem class
    Set colItems = objWMIService.ExecQuery("Select * from Win32_OperatingSystem")

    ' Loop through the results and return the build number
    For Each objItem in colItems
        GetBuildNumber = objItem.BuildNumber
        Exit Function
    Next
End Function